<?php

namespace AMZcockpitDoctrine\Repository;

/**
 * InvoiceRepository
 *
 * This class was generated by the Doctrine ORM. Add your own custom
 * repository methods below.
 */
class InvoiceRepository extends \Doctrine\ORM\EntityRepository
{
    public function getInvoiceCount() {
        /** @var \Doctrine\ORM\QueryBuilder $qb */
        $qb = $this->createQueryBuilder('i');
        $qb->select('COUNT(i)');

        return $qb->getQuery()->getSingleScalarResult();
    }

    public function getGainsLastYear() {

        $date = new \DateTime();
        $date->modify('-12 month');
        $mois = [ "Jan", "Fév", "Mar", "Avr", "Mai", "Juin", "Juil", "Aout", "Sep", "Oct", "Nov", "Déc" ];

        $qb = $this->createQueryBuilder('i');
        $date->setDate($date->format('Y'), $date->format('m') , 1);
        $date->setTime(0, 0,0 );

        $qb->select('MONTH(i.createdAt) AS gDmonth, YEAR(i.createdAt) AS gDyear, SUM(i.amount) as income, COUNT(i.id) as _count');
        $qb->addGroupBy('gDmonth')
            ->addGroupBy('gDyear');

        $qb->orderBy('gDyear','ASC');
        $qb->addOrderBy('gDmonth','ASC');

        $qb->andWhere($qb->expr()->gte('i.createdAt',':date'))
            ->setParameter('date',$date);

        $items = $qb->getQuery()->getResult();

        $incomeDays = [];
        foreach ($items as $item)
            $incomeDays[$mois[$item['gDmonth']-1].' '.$item['gDyear']] = [
                'income'    => $item['income']/100,
                'total'     => $item['_count']
            ];

        $return = [];
        foreach ($incomeDays as $month => $item)
        {
            $return[] = [
                'day'       => $month,
                'text'     => number_format($item['income'],2)." €",
                'income'    => round($item['income'], 2),
                'total'     => $item['total']
            ];
        }

        return $return;
    }

}
